define('components/tab/1.0.0/js/tab', [

], function() {
    var defaultOpts = {
        index: 0,
        containerId: '',
        tabItemClass: 'm-tab-item',
        tabContClass: 'm-tab-cont'
    }

    var Tab = function(options) {
        this.options = $.extend({}, defaultOpts, options);
        this.init();
    }

    Tab.prototype = {
        init: function() {
            var options = this.options,
                $container = this.$container = $(options.containerId);

            this.$tabItems = $container.find(options.tabItemClass);
            this.$tabConts = $container.find(options.tabContClass);

            this.bindEvents();

            this.select(options.index);
        },
        bindEvents: function() {
            var options = this.options;

            this.$container.on('tap', options.tabItemClass, this.handlers.tabClick.bind(this))
        },
        select: function(index) {
            this.$tabItems.eq(index).trigger('tap');
        },
        handlers: {
            tabClick: function(e) {
                var $target = $(e.currentTarget),
                    index = this.$tabItems.index($target);

                this.$tabItems.removeClass('st-active');
                $target.addClass('st-active');
                this.$tabConts.hide().eq(index).show();
            }
        }
    }

    return Tab;
});
