require([
    'modules/about/1.0.0/data/feedback.mock'
], function(res) {
    var FeedbackView = FView.extend({
        init: function() {
            Hyperion.actions.setHeader({
                title: '我要吐槽',
                isBack: true,
                backCallback: function() {
                    Hyperion.actions.back();
                },
                isClose: false,
                closeCallback: function() {
                    Hyperion.actions.close();
                }
            });
            this.bindEvents();
        },
        data: {
            complaintInfo: '',
            mobileNo: '',
            complaintType: '1',
            sex: '1',
            customerName: '',
            email: ''
        },
        bindEvents: function() {
            var data = this.data;
            var validateForm = this.validateForm;
            var submitCb = this.submitCb;
            var request = this.request;
            //类型选择
            $('#wapCategory li').bind('tap', function() {
                var $this = $(this);
                $this.children('p').addClass('active');
                $this.siblings().children('p').removeClass('active');
                data.category = $this.data('value').toString();
            });
            // 性别选择
            $('.sex-selector').bind('tap', function() {
                var $this = $(this);
                $this.children('p').addClass('active');
                $this.siblings('.sex-selector').children('p').removeClass('active');
                data.sex = $this.data('value').toString();
            });
            //提交
            $('#submit').bind('tap', function() {
                if (validateForm(data)) {
                    Hyperion.actions.loadingBegin({
                        type: 'local'
                    });
                    request({
                        'url': '/btoa/portal/user/gz/complaintInfo',
                        'error': function() {
                            Hyperion.actions.tip({
                                'text': '网络异常请稍后重试'
                            });
                        },
                        'data': data,
                        'success': function(res) {

                            Hyperion.actions.loadingFinish({
                                type: 'local'
                            });

                            if (typeof res !== 'object') {
                                res = $.parseJSON(res);
                            }
                            if (res.code === '000000') {
                                submitCb();
                            } else {
                                Hyperion.actions.tip({
                                    'text': res.message
                                });
                            }
                        }
                    });
                }
            });

            $('#message-input').bind('blur', function() {
                var message = $('#message-input').val();
                message = $.trim(message);
                if (message.length > 100) {
                    Hyperion.actions.tip({
                        'text': '留言长度不能超过一百个汉字'
                    }, function() {});
                }
            });

            $('#name-input').bind('blur', function() {
                var name = $(this).val();
                name = $.trim(name);
                if (name.length > 10) {
                    Hyperion.actions.tip({
                        'text': '联系人长度不能超过10个汉字'
                    }, function() {});
                }
            });

            $('#phone-input').bind('blur', function() {
                var phone = $(this).val();
                var mobilereg = /^1\d{10}$/;
                if (phone && !mobilereg.test(phone)) {
                    Hyperion.actions.tip({
                        'text': '手机号码格式错误'
                    });
                }
            });

            $('#email-input').bind('blur', function() {
                //TODO 校验手机号
                var emailreg = /^([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+@([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+\.[a-zA-Z]{2,3}$/;
                var email = $('#email-input').val();
                if (email && !emailreg.test(email)) {
                    Hyperion.actions.tip({
                        'text': '邮箱格式错误'
                    });
                } else if ($.trim(email).length > 75) {
                    Hyperion.actions.tip({
                        'text': '邮箱长度过长'
                    });
                }
            });

        },
        //表单校验
        validateForm: function(data) {
            var message = $('#message-input').val();
            message = $.trim(message);
            //校验留言
            if (!message) {
                Hyperion.actions.tip({
                    'text': '留言不能为空'
                }, function() {});
                return false;
            }
            var name = $('#name-input').val();
            //TODO 校验姓名
            var telreg = /^0\d{2,3}-?\d{7,8}$/;
            var mobilereg = /^1\d{10}$/;
            var phone = $('#phone-input').val();
            if (phone && !mobilereg.test(phone)) {
                Hyperion.actions.tip({
                    'text': '手机号码格式错误'
                });
                return false;
            }

            //TODO 校验手机号
            var emailreg = /^([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+@([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+\.[a-zA-Z]{2,3}$/;
            var email = $('#email-input').val();
            if (email && !emailreg.test(email)) {
                Hyperion.actions.tip({
                    'text': '邮箱格式错误'
                });
                return false;
            } else if ($.trim(email).length > 75) {
                Hyperion.actions.tip({
                    'text': '邮箱长度过长'
                });
                return false;
            }

            data.complaintInfo = message;
            data.mobileNo = phone;
            data.email = email;
            data.customerName = name;

            return true;
        },
        //提交成功回调
        submitCb: function() {
            // Hyperion.actions.forward({
            //     url: 'http://10.180.146.100/modules/about/1.0.0/views/feedback-succ.html',
            //     type: 'external'
            // });
            Hyperion.actions.forward({
                url: 'modules/about/1.0.0/views/feedback-succ.html'
            });
        }
    });

    new FeedbackView();
});
