require([
    'text!modules/bind-card/1.0.0/views/select-list-tpl.html',
    'components/keyboard/1.0.0/js/keyboard'
], function (listTpl, Keyboard) {
    var self = this;
    var information = {
        'cardId': false,
        'bankName': false,
        'pwd': false,
        'msg': false
    };
    var bankList = {};
    var $bankList = $('#bankList');
    var cardBin = {};
    var isBank = null;
    var binCardInfo = {};
    var time = 59;
    var operationType = ''; //确定对卡的操作类型
    listTpl = template.compile(listTpl);
    var RecommendView = FView.extend({
        source: '',
        opt: '',
        events: {
            'blur #cardId': 'e_CardIdBlur',
            'tap #getSmsToken.active': 'e_TapSendMessage', //  获取短信验证码
            'change #selectBankName': 'e_selectChange',
            // 'blur #pwd': 'e_PwdBlur',
            // 'focus #pwd': 'e_PwdFocus',
            'keyboardBlur #pwd': 'E_passwordKeyboard',
            'tap #nextStep.error': 'e_NextStepTap1',
            'blur #_SMSToken': 'blurSMSToken',//校验验证码
            'tap #nextStep.active': 'e_NextStepTap',
            'touchstart .gz-close': 'e_CloseTap',
            'tap #sure': 'e_SureTap'

        },
        init: function () {
            self = this;
            self.source = this.query.source;
            self.opt = this.query.opt;
            this.getRecommendData(function () {
                // 获取银行列表
                self.request({
                    url: '/btoa/portal/account/getBankList',
                    debug: false,
                    type: 'get',
                    success: function (data) {
                        console.log(data.data);
                        bankList = data.data.bankList;
                        $('#bankList').hide();
                        $bankList.html(listTpl({
                            data: bankList
                        }));
                    },
                    error: function () {

                    }
                });
                //  获取公钥
                self.request({
                    url: '/btoa/portal/common/getBankPublicKey',
                    type: 'get',
                    data: {},
                    success: function (data) {
                        if (data === null) {
                            Hyperion.actions.tip({
                                text: '服务器异常！',
                                time: 2000
                            });
                            return;
                        }
                        if (data.code !== '000000') {
                            Hyperion.actions.tip({text: data.msg});
                            return;
                        }
                        binCardInfo.publicKey = data.data.publicKey;
                    },
                    error: function () {

                    }
                });
                // 获取用户信息
                self.getUserInfo(
                    function (d) {
                        binCardInfo = d;
                        console.log(binCardInfo);
                    }
                );

                // 获取用户信息(暂时没有开户成功)
                self.request({
                    url: '/btoa/work/account/getElecAccountInfo',
                    type: 'get',
                    data: {},
                    success: function (data) {
                        if (data === null) {
                            Hyperion.actions.tip({
                                text: '服务器异常！',
                                time: 2000
                            });
                            return;
                        }
                        if (data.code !== '000000') {
                            Hyperion.actions.tip({
                                text: data.msg,
                                time: 2000
                            });
                            return;
                        }
                        console.log(data.data.acNo);
                        binCardInfo.acNo = data.data.acNo;
                        binCardInfo.bankName = data.data.bankName;
                    },
                    error: function () {

                    }
                });

                // 初始化时，调用密码键盘
                function createKeyboard(options) {
                    var key = new Keyboard(options);
                    return key;
                }

                createKeyboard({
                    containsID: "keyboardContent",
                    maxLength: '6',
                    id: 'pwd',
                    placeholder: '请输入取款密码',
                    type: '2',
                    press: function (val) {

                    },
                    keyPressCallback: function (val) {
                        $('#pwd').val(val);
                    },
                    complete: function (val) {

                    },
                    focus: function () {
                        $(".bindCard").css({
                            "padding-bottom": "300px"
                        });
                    },
                    blur: function () {
                        information.pwd = self.checkCardPwd($("#pwd").val());
                        self.enableNextStep();
                        $(".bindCard").css({
                            "padding-bottom": "0"
                        });
                    }
                });
                self.setHeader();
                self.confirmOptType();
            });
        },
        getRecommendData: function (cb) {
            if (typeof cb === 'function') {
                cb();
            }
        },
        confirmOptType: function () {
            var check = (self.opt === '1');
            /* var fire = (self.source === 'fire');
             if (check) {
             operationType = '2';
             } else if (fire) {
             operationType = '3';
             }else {
             operationType = '1';
             }*/
            if (check) {
                operationType = '2';
            } else {
                operationType = '1';
            }
        },
        setHeader: function () {
            /**
             * 通过地址中的参数判断其是否为”承接流程“，还是”单个流程“
             * 1. 单个流程：有返回按钮，有关闭按钮（关闭按钮没有返回上个流程的加逻辑）。
             * 2. 承接流程：没有返回按钮，有关闭按钮（关闭按钮需要加上 返回上个流程的成功页面），
             */
            var hasBackBtn = (this.source === 'licai');
            var hasCloseBtn = (this.source === 'open');
            var hasChangeCard = (this.opt === '1');
            if (hasChangeCard) {
                Hyperion.actions.setHeader(
                    {
                        title: '改绑银行卡',
                        //  返回按钮，需要判断是不是流程内的
                        isBack: true,
                        backCallback: function () {
                            Hyperion.actions.onEvent({ eventId: "10702-改绑_银行卡信息录入页", eventLable: "1070201-点击“返回”"});
                            Hyperion.actions.back();
                        },
                        //  关闭按钮，需要判断是不是流程内的
                        isClose: true,
                        closeCallback: function () {
                            Hyperion.actions.onEvent({ eventId: "10702-改绑_银行卡信息录入页", eventLable: "1070202-点击“关闭”"});
                            Hyperion.actions.close();
                        }
                    }, function () {
                    }
                );
            } else {
                if (hasBackBtn || hasCloseBtn) {
                    Hyperion.actions.onEvent({ eventId: "10601-绑卡_银行卡信息录入页", eventLable: "1060104-跳转来源", BannerName: "开通"});
                } else {
                    Hyperion.actions.onEvent({ eventId: "10601-绑卡_银行卡信息录入页", eventLable: "1060104-跳转来源", BannerName: "绑卡"});
                }
                Hyperion.actions.setHeader(
                    {
                        title: '绑定银行卡',
                        //  返回按钮，需要判断是不是流程内的
                        isBack: hasBackBtn,
                        backCallback: function () {
                            Hyperion.actions.onEvent({ eventId: "10601-绑卡_银行卡信息录入页", eventLable: "1060101-点击“返回”"});
                            Hyperion.actions.back();
                        },
                        //  关闭按钮，需要判断是不是流程内的
                        isClose: true,
                        closeCallback: function () {
                            /**
                             *   判断从哪里来
                             * 1.从理财页面来。
                             * 2.从注册（开户）流程来
                             *
                             */
                            if (hasBackBtn) {
                                Hyperion.actions.onEvent({ eventId: "10601-绑卡_银行卡信息录入页", eventLable: "1060102-点击“关闭”"});
                                Hyperion.actions.close();
                            } else if (hasCloseBtn) {
                                $('#closeConfim').show().css("height", $('body')[0].scrollHeight);
                            } else {
                                Hyperion.actions.onEvent({ eventId: "10601-绑卡_银行卡信息录入页", eventLable: "1060102-点击“关闭”"});
                                Hyperion.actions.close();
                            }
                        }
                    }, function () {
                    }
                );
            }

        },
        //倒计时
        timeComputeS: function () {
            if (time === 0) {
                time = 59;
                $('#getSmsToken').addClass('active');
                $('#smsTip').show();
                $("#getSmsToken").html("重新发送");
            } else {
                $('#smsTip').hide();
                $("#getSmsToken").html(time + "秒后重新获取");
                time--;
                setTimeout(self.timeComputeS, 1000);
            }
        },
        enableNextStep: function () {
            if (isBank === true) {
                if (information.cardId && information.bankName && information.pwd && information.msg) {
                    $("#nextStep").removeClass('error');
                    $("#nextStep").addClass('active');
                } else {
                    $("#nextStep").removeClass('active');
                    $("#nextStep").addClass('error');
                }
            } else {
                if (information.cardId && information.bankName && information.msg) {
                    $("#nextStep").removeClass('error');
                    $("#nextStep").addClass('active');
                } else {
                    $("#nextStep").removeClass('active');
                    $("#nextStep").addClass('error');
                }
            }

        },
        checkBankCardId: function (cardId) {
            var reg = /(^\d{16,19}$)/;
            if (cardId === "" || cardId === null) {
                Hyperion.actions.tip({
                    text: "请正确输入卡号",
                    time: 1500
                });
                return false;
            }
            //比较强验证身份证,基本判定身份格式正确
            if (reg.test(cardId) === false) {
                Hyperion.actions.tip({
                    text: "请正确输入卡号",
                    time: 1500
                });
                return false;
            }
            return true;
        },
        checkSMSToken: function (vSMSToken) {
            var reg = /^\d{6}$/;
            if (vSMSToken === null || vSMSToken === "") {
                Hyperion.actions.tip({
                    text: "请输入6位验证码",
                    time: 1500
                });
                return false;
            }

            if (!reg.test(vSMSToken)) {
                Hyperion.actions.tip({
                    text: "请输入6位验证码",
                    time: 1500
                });
                return false;
            }
            information.msg = true;
            return true;
        },
        checkBankName: function (bankName) {
            var reg = /^[\u4e00-\u9fa5]+$/;
            if (bankName === "" || bankName === null) {
                Hyperion.actions.tip({
                    text: "请输入银行名",
                    time: 1500
                });
                return false;
            }
            if (reg.test(bankName) === false) {
                Hyperion.actions.tip({
                    text: "您输入银行名错误",
                    time: 1500
                });
                return false;
            }
            return true;
        },
        checkCardPwd: function (pwd) {

            if (pwd === "" || pwd === null) {
                // Hyperion.actions.tip({text: "请输入6位数字"});
                return false;
            }
            if (pwd.length !== 6) {
                Hyperion.actions.tip({
                    text: "请输入6位数字",
                    time: 1500
                });
                return false;
            }
            return true;
        },
        handlers: {
            'e_CardIdBlur': function () {
                information.cardId = self.checkBankCardId($("#cardId").val());
                // “卡BIN” 判断是不是本行卡。（没有获得本行卡的卡BIN）
                if (!information.cardId) {
                    return;
                }
                self.request({
                    url: '/btoa/portal/account/getSuperBankInfoByCardNo',
                    type: 'get',
                    data: {
                        'cardNo': $('#cardId').val()
                    },
                    success: function (data) {
                        if (data.code === '000000') {
                            cardBin = data.data;
                            console.log(cardBin);
                            if (!information.cardId) {
                                return;
                            }
                            if (cardBin.bankFlag === true) {
                                isBank = true;
                                information.bankName = true;
                                self.enableNextStep();
                                $('select').val(cardBin.bankId);
                                binCardInfo.payeeBankId = cardBin.bankId;
                                binCardInfo.payeeBankName = $.trim($('select').find("option").eq($('select')[0].selectedIndex).text());
                                $('#bankList').show();
                                $('#checkPwd').show();
                            } else {
                                isBank = false;
                                $('#checkPwd').hide();
                                information.bankName = true;
                                $('select').val(cardBin.bankId);
                                binCardInfo.payeeBankId = cardBin.bankId;
                                binCardInfo.payeeBankName = $.trim($('select').find("option").eq($('select')[0].selectedIndex).text());
                                self.enableNextStep();
                                $('#bankList').show();
                            }
                        }
                    },
                    error: function () {

                    }
                });
            },
            'E_passwordKeyboard': function () {
                self.checkCardPwd();
            },
            'e_CloseTap': function (e) {
                e.stopImmediatePropagation();
                e.preventDefault();
                $('#closeConfim').hide();
            },
            e_TapSendMessage: function () {
                $("#getSmsToken").removeClass('active');
                self.request({
                    url: '/btoa/work/common/sendSmsOtp',
                    type: 'get',
                    data: {
                        //'mobileNo': binCardInfo.mobileNo,
                        'idNo': binCardInfo.idNo,
                        'otpType': '2'
                        //'otpType': '3'
                    },
                    success: function (data) {
                        console.log(data);
                        if (data.code !== '000000') {
                            Hyperion.actions.tip({
                                text: '验证发送失败',
                                time: 2000
                            });
                            $('#getSmsToken').addClass('active');
                            return;
                        } else {
                            Hyperion.actions.tip({
                                text: "验证码发送成功",
                                time: 2000
                            });
                            self.timeComputeS();
                        }
                    },
                    error: function (data) {
                        Hyperion.actions.tip({
                            text: '验证发送失败',
                            time: 2000
                        });
                        $('#getSmsToken').addClass('active');
                    }
                });
            },

            'e_NextStepTap1': function () {
                Hyperion.actions.tip({
                    text: "请正确填写信息",
                    time: 1500
                });
            },
            'e_selectChange': function () {
                var $select = $('select').val();
                if ($select === '') {
                    Hyperion.actions.tip({
                        text: '请选择银行',
                        time: 1500
                    });
                    information.bankName = false;
                    self.enableNextStep();
                    $('#checkPwd').hide();
                } else {
                    information.bankName = true;
                    binCardInfo.payeeBankId = $select;
                    binCardInfo.payeeBankName = $.trim($('select').find("option").eq($('select')[0].selectedIndex).text());
                    if ($select === '313581003284') {
                        isBank = true;
                        $('#checkPwd').show();
                        self.enableNextStep();
                    } else {
                        isBank = false;
                        self.enableNextStep();
                        $('#checkPwd').hide();
                    }
                    console.log(binCardInfo);
                }
            },
            'e_PwdBlur': function () {
                //缺少加密方法，没有数字密码键盘

            },
            'e_SureTap': function () {
                Hyperion.actions.forward({
                    url: 'modules/open-account/1.0.0/views/openAccuSuc.html',
                    data: {
                        source: 'change'
                    }
                });
            },
            blurSMSToken: function () {
                information.msg = self.checkSMSToken($("#_SMSToken").val());
                self.enableNextStep();
            },
            'e_NextStepTap': function () {
                console.log(binCardInfo);
                if (operationType === 2) {
                    Hyperion.actions.onEvent({ eventId: "10702-改绑_银行卡信息录入页", eventLable: "1070203-点击“确定”"});
                } else {
                    Hyperion.actions.onEvent({ eventId: "10601-绑卡_银行卡信息录入页", eventLable: "1060103-点击“确定”"});
                }
                // 判断是不是本行卡，来确定要不要加密方法
                if (isBank) {
                    self.request({
                        url: '/btoa/portal/common/gz/getTimestamp',
                        type: 'get',
                        data: {},
                        success: function (data) {
                            console.log(data);
                            binCardInfo.serviceTime = data.data.serviceTime;
                            Hyperion.actions.getEncodedPSW({
                                publicKey: binCardInfo.publicKey,
                                data: $('#pwd').val(),
                                timeStamp: binCardInfo.serviceTime
                            }, function (status, result) {
                                if (result) {
                                    binCardInfo.binCardInfoPwd = result;
                                    self.request({
                                        url: '/btoa/work/account/bindCard',
                                        type: 'post',
                                        data: {
                                            'payeeAcNo': $('#cardId').val(),
                                            'payeeAcName': binCardInfo.cnName,//绑定账户名
                                            'payeeBankId': binCardInfo.payeeBankId,//绑定的银行号
                                            'payeeBankName': binCardInfo.payeeBankName,//绑定的银行名称
                                            'payerAcName': binCardInfo.cnName,//电子账户名称
                                            'operationType': operationType,//操作类型（1.绑定，2.改绑）
                                            'trasPassword': binCardInfo.binCardInfoPwd,
                                            'smsCode': $('#_SMSToken').val()
                                        },
                                        success: function (data) {
                                            if (data === null) {
                                                Hyperion.actions.tip({
                                                    text: '系统异常，请稍后再试！',
                                                    time: 1500
                                                });
                                                return;
                                            } else {
                                                if (data.code !== '000000') {
                                                    Hyperion.actions.tip({text: data.msg});
                                                    return;
                                                } else {
                                                    Hyperion.actions.setData({
                                                        name: 'bindCardInfo',
                                                        value: {
                                                            acNo: binCardInfo.acNo,
                                                            bankName: binCardInfo.bankName
                                                        }
                                                    }, function () {
                                                        if (operationType === '1') {
                                                            // 绑卡成功通知native
                                                            Hyperion.actions.notifyNativeEvent({
                                                                eventName: "bindCard",
                                                                data: {result: "true"}
                                                            });
                                                            Hyperion.actions.forward({
                                                                url: 'modules/bind-card/1.0.0/views/bindCardSuc.html',
                                                                data: {
                                                                    isBank: '1',
                                                                    opt: '0'
                                                                }
                                                            });
                                                        } else {
                                                            // 改绑成功通知native
                                                            Hyperion.actions.notifyNativeEvent({
                                                                eventName: "changeBind",
                                                                data: {result: "true"}
                                                            });
                                                            Hyperion.actions.forward({
                                                                url: 'modules/bind-card/1.0.0/views/bindCardSuc.html',
                                                                data: {
                                                                    opt: '1',
                                                                    isBank: '1'
                                                                }
                                                            });
                                                        }
                                                    });

                                                }
                                            }

                                        },
                                        error: function () {

                                        }
                                    });
                                } else {
                                    Hyperion.actions.tip({
                                        text: '服务异常，请稍候再试',
                                        time: 1500
                                    });
                                }
                            });
                        },
                        error: function () {
                        }
                    });
                } else {
                    self.request({
                        url: '/btoa/work/account/bindCard',
                        type: 'post',
                        data: {
                            'payeeAcNo': $('#cardId').val(),
                            'payeeAcName': binCardInfo.cnName,//绑定账户名
                            'payeeBankId': binCardInfo.payeeBankId,//绑定的银行号
                            'payeeBankName': binCardInfo.payeeBankName,//绑定的银行名称
                            'payerAcName': binCardInfo.cnName,//电子账户名称
                            'operationType': operationType,//操作类型（1.绑定，2.改绑）
                            'smsCode': $('#_SMSToken').val()
                        },
                        success: function (data) {
                            if (data.code !== '000000') {
                                Hyperion.actions.tip({text: data.msg});
                            } else {
                                Hyperion.actions.setData({
                                    name: 'bindCardInfo',
                                    value: {
                                        acNo: binCardInfo.acNo,
                                        bankName: binCardInfo.bankName
                                    }
                                }, function () {
                                    if (operationType === '1') {
                                        // 绑卡成功通知native
                                        Hyperion.actions.notifyNativeEvent({
                                            eventName: "bindCard",
                                            data: {result: "true"}
                                        });
                                        Hyperion.actions.forward({
                                            url: 'modules/bind-card/1.0.0/views/bindCardSuc.html',
                                            data: {
                                                isBank: '0',
                                                opt: '0'
                                            }
                                        });
                                    } else {
                                        // 改绑成功通知native
                                        Hyperion.actions.notifyNativeEvent({
                                            eventName: "changeBind",
                                            data: {result: "true"}
                                        });
                                        Hyperion.actions.forward({
                                            url: 'modules/bind-card/1.0.0/views/bindCardSuc.html',
                                            data: {
                                                opt: '1',
                                                isBank: '0'
                                            }
                                        });
                                    }
                                });
                            }
                        },
                        error: function () {

                        }
                    });
                }
            }
        }
    });

    new RecommendView();
});
