/**
 * EX-HUANGYIWU-001
 */
require([
    'text!modules/licai/1.0.0/views/licai-cancel-tpl.html'
], function (detailTpl) {
    var time = 59;
    var self = this;
    var financalTt = {};        //获取数据的全局变量
    //var calfinancal = {};       //存储数据的全局变量
    var liCaiListData = {};     //获取数据的全局变量
    // isDev 是否为开发模式
    var isDev = false,
        Urls = isDev ? {
            productList: "../data/xiangqing.json",                     //获取产品列表详情
            detailUrl: "../data/ererer.json",                          //取消理财产品
            phoneUrl: "../data/phone.json"                             //向手机发送验证码，本地
        } : {
            productList: "/btoa/portal/finance/gz/getPrdList",         //获取产品列表详情
            detailUrl: "/btoa/work/finance/gz/productCancel",          //取消理财产品，接口
            phoneUrl: "/btoa/work/common/sendSmsOtp",                  //向手机发送验证码，接口
            getElecAccountInfo: "/btoa/work/account/getElecAccountInfo",//查询电子帐户
            getCustRisk: "/btoa/work/finance/gz/getCustRisk"             //查询用户的风险等级
        };
    var DetailView = FView.extend({
        events: {
            "tap #getSmsToken": "e_getSmsToken",                 //获取手机验证码
            "tap #cancel": "e_cancel",                           //取消认购发请求
            "focus #phoneVerification": "e_phone",               //输入框获取焦点
            "blur #phoneVerification": "e_phoneVerification"     //判断提交取消认购按钮
        },
        init: function () {
            'use strict';
            self = this;
            var list = {};
            list = this.query;
            if (list.as) {
                Hyperion.actions.getData(
                    {name: 'detailData'},
                    function (r, d) {
                        var date = d;
                        date.instrt = FUtil.formatCurrency(date.instrt);//转换年化率
                        self.getUserInfo(function (data) {
                            console.log(data);
                            if (data) {
                                date.cnName = data.cnName;
                            }
                        });
                        self.request({
                            debug: isDev,
                            url: Urls.getElecAccountInfo,
                            //请求成功的回调函数
                            success: function (data) {
                                console.log(data);
                                if (data.code === "000000") {
                                    date.acNo = FUtil.encryptAcNo(data.data.acNo);//转换卡号(加掩码)
                                    date.bankName = data.data.bankName;
                                    self.renderDetai(date);
                                    liCaiListData = date;
                                }
                            },
                            //请求失败的回调函数
                            error: function (res) {
                                Hyperion.actions.tip({
                                    text: res.msg
                                });
                            }
                        });
                    });
            } else {
                Hyperion.actions.getData(
                    {name: 'licaiCancel'},
                    function (r, d) {
                        var date = d.cancelData, riskType, detailsData = null;
                        date.instrt = FUtil.formatCurrency(date.instrt);//转换年化率
                        date.beginDate = date.beginDate.replace(/^(\d{4})(\d{2})(\d{2})$/, "$1/$2/$3");
                        date.buyBeginTime = date.beginDate.replace(/^(\d{4})(\d{2})(\d{2})$/, "$1/$2/$3");
                        console.log(date);
                        //var date=d;
                        self.getUserInfo(function (data) {
                            console.log(data);
                            if (data) {
                                date.cnName = data.cnName;
                            }
                        });
                        //银行卡列表
                        self.request({
                            debug: isDev,
                            url: Urls.getElecAccountInfo,
                            //请求成功的回调函数
                            success: function (data) {
                                if (data.code === "000000") {
                                    console.log(data.data);
                                    //date.acNo = data.data.acNo;
                                    date.acNo = FUtil.encryptAcNo(data.data.acNo);//转换卡号(加掩码)
                                    date.bankName = data.data.bankName;
                                    //date.bankId=data.data.cardList[0].bankId;
                                    //获取用户的级别
                                    self.request({
                                        debug: isDev,
                                        url: Urls.getCustRisk,
                                        success: function (data) {
                                            console.log(data);
                                            if (data && data.data.riskType) {
                                                var map = ['', '保守型', '安稳型', '稳健型', '成长型', '积极型'];
                                                riskType = data.data.riskType;
                                                console.log(riskType);
                                                //var map={'1':'保守型','2':'安稳型'};
                                                //console.log(riskType);
                                                date.riskType = map[riskType];
                                                self.renderDetai(date);
                                                liCaiListData = date;
                                            }
                                        },
                                        error: function (res) {
                                            console.log(res);
                                            Hyperion.actions.tip({
                                                text: res.msg
                                            });
                                        }
                                    });
                                }
                            },
                            error: function (res) {
                                console.log(res);
                                Hyperion.actions.tip({
                                    text: res.msg
                                });
                            }
                        });

                    });

            }
            // 设置title
            Hyperion.actions.setHeader({
                title: '取消认购产品信息',
                isBack: true,
                backCallback: function () {
                    Hyperion.actions.back();
                },
                isClose: true,
                closeCallback: function () {
                    Hyperion.actions.onEvent({eventId: "10203-我的理财_取消认购确认页", eventLable: "1020301-点击“关闭”"});
                    Hyperion.actions.close();
                }
            });
        },
        //页面的数据渲染
        renderDetai: function (data) {
            if (data) {
                this.render(template.compile(detailTpl), {
                    // 模板填充
                    data: data,
                    moment: moment
                });
            } else {
                //alert('文章不存在或已被删除！');
                //Hyperion.actions.back();
            }
        },
        //倒计时(新)
        timeCompute: function () {
            if (time === 0) {
                time = 59;
                $('#getSmsToken').addClass('active');
                $('#getSmsToken').show();
                $("#getSmsToken").html("重新发送");
            } else {
                $('#getSmsToken').removeClass('active');
                $('#getSmsToken').show();
                $("#getSmsToken").html(time + "重新获取");
                time--;
                setTimeout(function () {
                    self.timeCompute();
                }, 1000);
            }
        },
        //短信倒计时（旧）
        //timeComputeS: function () {
        //    var self = this;
        //    if (time === 0) {
        //        time = 59;
        //        $("#SMSSendDelay").hide();
        //        $("#getSmsToken").html("重新获取");
        //        $("#getSmsToken").show();
        //    } else {
        //        $("#getSmsToken").hide();
        //        $("#SMSSendDelay").show();
        //        $("#SMSSendDelay").html("(" + time + ")重新获取");
        //        time--;
        //        setTimeout(function () {
        //            self.timeComputeS();
        //        }, 1000);
        //    }
        //},
        handlers: {
            //发送手机验证码
            "e_getSmsToken": function () {
                //发送请求,获取手机验证码
                var data = null, self = this;
                var input = $('#phoneVerification').val();
                var Display = $('#cancel');
                self.request({
                    debug: isDev,
                    url: Urls.phoneUrl,
                    type: "get",
                    data: {
                        otpType: 8
                    },
                    //请求成功的回调函数
                    success: function (data) {
                        console.log(data);
                        //console.log("获取验证码成功");
                        //倒计时的实现（新）
                        self.timeCompute();
                        //倒计时的实现（旧）
                        //self.timeComputeS();
                        //各种手机验证码的发送情况的检查
                        this.timeClickFlag = true;
                        if (data === '') {
                            Hyperion.actions.tip({text: "系统繁忙,请稍后再试!"});
                            self.timeClickFlag = true;
                            return;
                        }
                        if (data.code === "000000") {
                            Hyperion.actions.tip({text: "发送手机验证码成功"});
                            $("#getSmsToken").hide();
                            $("#SMSSendDelay").show();
                            //self.timeCompute();
                        } else {
                            Hyperion.actions.tip({text: (data.msg) === '' ? "发送手机验证码失败" : data.msg});
                            $("#SMSSendDelay").hide();
                            $("#getSmsToken").html("重新获取");
                            $("#getSmsToken").show();
                        }
                    },
                    //请求失败的回调函数
                    error: function (data) {
                        console.log(data);
                        Hyperion.actions.tip({
                            text: data.msg
                        });
                    }
                });
            },
            //判断提交取消认购按钮
            "e_phoneVerification": function (data) {
                var display = $("#phoneVerification").parents('.textfield'),
                    input = $('#phoneVerification').val().trim(),
                //reng=/^\d{6}$/,
                    Display = $('#cancel');
                //display.remove('active');
                var beforeLabel = $("#phoneVerification").parents("li").siblings("li.textfield-label");
                var selfInput = $("#phoneVerification");
                if (beforeLabel && beforeLabel.length) {
                    beforeLabel.show();
                    display.removeClass('active');
                    $("#phoneVerification").removeAttr("placeholder", beforeLabel.text());
                }
                //var tip=$(this).parents('.textfield-frame').find('.textfield-tip');
                if ((input.length >= 0) && (input.length < 6)) {
                    Hyperion.actions.tip({text: "请输入六位数字"});
                    Display.removeClass('active');
                    //Hyperion.actions.tip({text: "身份证不能为空"});
                    // return false;
                } else {
                    Display.addClass('active');
                }
            },
            //获取焦点事件
            "e_phone": function () {
                var display = $("#phoneVerification").parents('.textfield'),
                    beforeLabel = $("#phoneVerification").parents("li").siblings("li.textfield-label"),
                    selfInput = $("#phoneVerification");
                display.addClass('active');
                if (beforeLabel && beforeLabel.length) {
                    beforeLabel.hide();
                    $("#phoneVerification").attr("placeholder", beforeLabel.text());
                }
            },
            //取消认购
            "e_cancel": function () {
                var cancel = $('#cancel');
                //发送请求的
                if (cancel.hasClass('active')) {
                    //发送请求
                    var self = this;
                    //取消按钮confirm实现
                    Hyperion.actions.confirm(
                        {
                            text: '您确定要取消认购广州红棉理财计划？',
                            leftBtnText: '确认',
                            // 左按钮点击回调函数_发送取消认购请求
                            leftBtnCallback: function () {
                                Hyperion.actions.onEvent({
                                    eventId: "10203-我的理财_取消认购确认页",
                                    eventLable: "1020302-点击“同意取消”"
                                });
                                //发送同意取消认购的请求
                                self.request({
                                    debug: isDev,
                                    url: Urls.detailUrl,
                                    data: {
                                        acNo: liCaiListData.accNo,
                                        contractNo: liCaiListData.agreeNo,
                                        productName: liCaiListData.productName,
                                        amount: liCaiListData.amount.replace(',', ''),
                                        currency: liCaiListData.currency,
                                        proType: "1",
                                        productId: liCaiListData.productId,
                                        smsCode: $('#phoneVerification').val().trim()
                                    },
                                    //请求成功的回调函数
                                    success: function (data) {
                                        console.log(data);
                                        //return;
                                        if (data.code === "000000") {
                                            // 取消认购理财通知native
                                            Hyperion.actions.notifyNativeEvent({
                                                eventName: "cancelFinance",
                                                data: {result: "true"}
                                            });
                                            //if(true){
                                            //存储本地数据，给下一个页面获取
                                            Hyperion.actions.setData({
                                                    name: 'cancelData',
                                                    value: liCaiListData
                                                },
                                                //跳转取消成功的连接
                                                function () {
                                                    Hyperion.actions.forward({
                                                        url: "modules/licai/1.0.0/views/licai-cancel-success.html"
                                                    });
                                                }
                                            );
                                        } else {
                                            //返回详细信息给用户
                                            Hyperion.actions.tip({
                                                text: data.msg,
                                                time: 2000
                                            })
                                        }
                                    },
                                    //请求失败的回调函数
                                    error: function (res) {
                                        Hyperion.actions.tip({
                                            text: res.msg
                                        });
                                    }
                                })
                            },
                            rightBtnText: "关闭",
                            // 左按钮点击回调函数_关闭confirm按钮
                            rightBtnCallback: function () {
                            }
                        }, function () {
                            //回调函数_没有方法
                        }
                    );

                }
            }
        }
    });
    new DetailView();
});
