require([
    'text!modules/licai/1.0.0/views/licai-list-tpl.html'
], function(listTpl) {
    var startX, startY, endX, endY = 0;
    var pageNo = 1;
    var pageSize = 10;
    var listCache = [];
    var isRequiring = false;
    var totalNum = 0;
    var LicaiListView = FView.extend({
        container: $('#licai-list'),
        init: function() {
            var self = this;
            // 设置title
            Hyperion.actions.setHeader({
                title: '红棉理财',
                isBack: true,
                backCallback: function() {
                    if (self.query.page === 'bindCard') {
                        Hyperion.actions.close();
                    } else {
                        Hyperion.actions.back();
                    }
                },
                isClose: true,
                closeCallback: function() {
                    Hyperion.actions.close();
                }

            });

            this.getLicaiList(function(data) {
                self.renderList(data);
            });

            //为每个item绑定点击事件
            $('#licai-list').on('tap', '.list-item', function(event) {
                var index = $(this).data('index') - 0;
                Hyperion.actions.setData({
                    name: 'licaiProduct',
                    value: listCache[index]
                });
                Hyperion.actions.forward({
                    url: 'modules/licai/1.0.0/views/licai-details.html'
                });

            });

            window.onscroll = function(event) {
                var scrollTop = $("body").scrollTop();
                var scrollHeight = document.documentElement.scrollHeight;
                var clientHeight = document.documentElement.clientHeight;

                if (Math.abs(scrollTop + clientHeight - scrollHeight) <= 100) {
                    if (isRequiring || totalNum === listCache.length + '') {
                        return;
                    }
                    pageNo++;
                    self.getLicaiList(function(data) {
                        self.renderList(data);
                    });
                }
            };

        },

        getLicaiList: function(cb) {

            isRequiring = true;

            this.request({
                'url': '/btoa/portal/finance/gz/getPrdList',
                'data': {
                    'pageNo': pageNo + '',
                    'pageSize': pageSize + '',
                    'queryType': '2',
                    'productType': '1'
                },
                'success': function(listData) {

                    isRequiring = false;
                    // 针对productName中的英文双引号转换为中文双引号
                    try {
                        listData = listData.replace(/\"productName\":\"\"(.*?)\"\,/gi, function($0, $1) {
                            return "\"productName\":\"“" + $1.replace(/\"/, "”") + "\","
                        });
                        listData = JSON.parse(listData);
                    } catch (e) {}

                    if (listData.code === '000000') {
                        if (listData.data) {
                            if (!totalNum) {
                                totalNum = listData.data.totalNum;
                            }
                            cb && cb(listData.data);
                        }
                    } else {
                        Hyperion.actions.tip({
                            text: listData.msg
                        });
                        self.removeIosEvent();
                        Hyperion.actions.back();
                    }
                }
            });
        },

        renderList: function(result) {
            var _this = this;
            var datas = result.prdList;

            //如果总数为0，
            if (result.totalNum === '0') {
                _this.render(listTpl, {
                    'datas': 'empty'
                }, "#licai-list", false);
                return;
            }

            $.each(datas, function(i) {
                datas[i].index = listCache.length + i;
                datas[i].productLimit = _this.getDateDiff(FUtil.parseDateStr(datas[i].productBeginDates), FUtil.parseDateStr(datas[i].productendDates));
                datas[i].incomeRating = FUtil.formatCurrency(datas[i].incomeRate);
            });

            var isAppend = true;
            if (pageNo === 1) {
                isAppend = false;
            }


            this.render(listTpl, {
                'datas': datas
            }, "#licai-list", isAppend);

            //缓存list;
            listCache = listCache.concat(datas);

        },

        getDateDiff: function(startDate, endDate) {
            var startTime = new Date(Date.parse(startDate.replace(/-/g, "/"))).getTime();
            var endTime = new Date(Date.parse(endDate.replace(/-/g, "/"))).getTime();
            var dates = Math.abs((endTime - startTime)) / (1000 * 60 * 60 * 24);
            return dates + '';
        }

    });

    new LicaiListView();
});
