require([
    'text!modules/licai/1.0.0/views/licai-myList-tpl.html'
], function(listTpl) {
    var startX, startY, endX, endY = 0;
    var pageNo = 1;
    var pageSize = 10;
    var listCache = [];
    var totalNum = 0;
    var isRequiring = false;
    var LicaiListView = FView.extend({
        container: $('#licai-mylist'),

        events: {
            'tap .item-right': 'cancleRengou'
        },

        init: function() {
            var self = this;

            // 设置title
            Hyperion.actions.setHeader({
                title: '我的理财',
                isBack: true,
                backCallback: function() {
                    self.removeIosEvent();
                    Hyperion.actions.back();

                },
                isClose: true,
                closeCallback: function() {
                    self.removeIosEvent();
                    Hyperion.actions.close();
                }

            });

            // 添加android - onBack监听
            Hyperion._handlers.onBack = function() {
                Hyperion.eventListener && Hyperion.eventListener.onBack.apply(this, arguments);
            };

            // 添加iOS - onBack监听
            Hyperion.actions.registNativeEvent({
                eventName: "onBackMessage",
                eventHandler: "onBack"
            });

            //添加返回事件处理
            Hyperion.eventListener.onBack = function() {
                pageNo = 1;
                self.getLicaiList(function(data) {
                    self.renderList(data);
                });
            };

            //请求数据
            self.getLicaiList(function(data) {
                self.renderList(data);
            });

            //为每个item绑定点击事件
            $('#licai-mylist').on('tap', '.item-left', function(event) {
                var index = $(this).parent().data('index') - 0;
                Hyperion.actions.setData({
                    name: 'myLicai',
                    value: {
                        'detailData': listCache[index]
                    }
                });
                Hyperion.actions.forward({
                    url: 'modules/licai/1.0.0/views/licai-position.html'
                });

            });

            //添加滚动事件
            window.onscroll = function(event) {
                var scrollTop = $("body").scrollTop();
                var scrollHeight = document.documentElement.scrollHeight;
                var clientHeight = document.documentElement.clientHeight;

                if (Math.abs(scrollTop + clientHeight - scrollHeight) <= 150) {
                    if (isRequiring || totalNum === listCache.length + '') {
                        return;
                    }
                    pageNo++;
                    self.getLicaiList(function(data) {
                        self.renderList(data);
                    });
                }
            };

            //绑定左滑事件
            $("body").swipeMenu();

        },
        // 移除iOS - onBack监听
        removeIosEvent: function() {

            Hyperion.actions.removeNativeEvent({
                eventName: "onBackMessage",
                eventHandler: "onBack"
            });
        },
        getLicaiList: function(cb) {
            var self = this;
            isRequiring = true;

            this.request({
                'url': '/btoa/work/finance/gz/getCustBuyList',
                'data': {
                    'pageNo': pageNo + '',
                    'pageSize': pageSize + '',
                    'searchBy': 2,
                    'agreeFlag': 1
                },
                'success': function(listData) {
                    isRequiring = false;
                    if (listData.code === '000000') {
                        if (typeof listData === 'string') {
                            listData = $.parseJSON(listData);
                        }
                        if (listData.data) {
                            if (!totalNum) {
                                totalNum = listData.data.totalNum;
                            }
                            cb && cb(listData.data);
                        }
                    } else {
                        Hyperion.actions.tip({
                            text: listData.msg
                        });
                        self.removeIosEvent();
                        Hyperion.actions.back();
                    }

                }
            });
        },

        renderList: function(result) {
            var _this = this,
                datas = result.prdList;

            $("#tolNum")[0].innerHTML = '目前还有' + result.totalNum + '笔未赎回';

            //如果总数为0，
            if (result.totalNum === '0') {
                this.render(listTpl, {
                    'datas': 'empty'
                }, "#l-cont", false);
                return;
            }

            var isAppend = true;
            if (pageNo === 1) {
                isAppend = false;
            }

            $.each(datas, function(i) {
                datas[i].index = listCache.length + i;
                datas[i].dateDiff = _this.getDateDiff(FUtil.parseDateStr(datas[i].beginDate), FUtil.parseDateStr(datas[i].matudt));
                datas[i].productLimit = _this.getDateDur(FUtil.parseDateStr(datas[i].beginDate), FUtil.parseDateStr(datas[i].matudt));
                datas[i].instrests = _this.getInstrests(datas[i]);
                datas[i].amount = FUtil.formatCurrency(datas[i].amount);
            });


            this.render(listTpl, {
                'datas': datas
            }, "#licai-mylist", isAppend);

            listCache = listCache.concat(datas);

        },

        getInstrests: function(data) {
            var limit = data.productLimit;
            var i = 0;
            if (i = limit.indexOf('天') !== -1) {
                limit = limit.substr(0, i + 1);
            }
            return FUtil.formatCurrency(data.amount * limit * data.instrt / 100 / 365);
        },

        handlers: {
            cancleRengou: function(event) {
                var index = $(event.currentTarget).parent().data('index') - 0;
                Hyperion.actions.setData({
                    name: 'licaiCancel',
                    value: {
                        'cancelData': listCache[index]
                    }
                });

                Hyperion.actions.forward({
                    url: 'modules/licai/1.0.0/views/licai-cancel.html'
                });
            }

        },
        getDateDiff: function(startDate, endDate) {
            var nowDate = moment().format('l');
            var nowTime = new Date(Date.parse(nowDate.replace(/-/g, "/"))).getTime();
            var startTime = new Date(Date.parse(startDate.replace(/-/g, "/"))).getTime();
            if (startTime > nowTime) {
                return startDate.replace(/-/g, "/") + '~' + endDate.replace(/-/g, "/") + '(尚未开始)';
            }
            var endTime = new Date(Date.parse(endDate.replace(/-/g, "/"))).getTime();
            var dates = Math.abs((endTime - nowTime)) / (1000 * 60 * 60 * 24);
            return dates + '';
        },
        getDateDur: function(startDate, endDate) {
            var startTime = new Date(Date.parse(startDate.replace(/-/g, "/"))).getTime();
            var endTime = new Date(Date.parse(endDate.replace(/-/g, "/"))).getTime();
            var dates = Math.abs((endTime - startTime)) / (1000 * 60 * 60 * 24);
            return dates + '天';
        }

    });

    new LicaiListView();
});
