require([
    'components/keyboard/1.0.0/js/keyboard'
], function (Keyboard) {
    var self = this;
    var defaultTips = {
        password: '输入6位数字交易密码',
        repeatPwd: '再次输入交易密码'
    };
    var localData = {};
    //该页缺少  加密方法 和  数字密码键盘，以及手机号码获取的方法。

    // input框检测是否正确
    var inputStatus = {
        password: false,
        repeatPwd: false,
        protocol: true
    };
    var Register = FView.extend({
        source: '',
        events: {
            /*  'input #password': 'E_InputPwd',
             'input #repeatPwd': 'E_InputRpwd',*/
            'tap #submit.error': 'E_SubmitError',
            'tap #submit.active': 'submit',//点击下一步
            //'tap #passwordDelete': 'deletePwd',//清空密码
            //'tap #repasswordDelete': 'deletePwd2',//清空密码
            'tap #servicesProtocalS': 'agreeProtocal',//协议
            'tap #eProtocal': 'eProtocal',//协议
            // 'blur #password': 'E_pPasswordBlur',
            // 'blur #repeatPwd': 'E_pRPasswordBlur',
            'keyboardBlur #password': 'E_passwordKeyboard',
            'keyboardBlur #repeatPwd': 'E_repeatpwdKeyboard',
            'touchstart .gz-close': 'E_closeTap',
            'tap #sure': 'E_SureTap'
            /* 'focus #password': 'E_focusPwd',
             'focus #repeatPwd': 'E_focusRePwd'*/
        },

        init: function () {
            self = this;
            self.source = this.query.source;
            this.getRecommendData(function (data) {
                self.setHeader();
                // 获取用户信息
                self.getUserInfo(
                    function (d) {
                        localData.mobileNo = d.mobileNo;
                    }
                );

                Hyperion.actions.getData({name: 'openAcount'},
                    function (rr, dd) {
                        localData = dd;
                        console.log(dd);
                    }
                );

                self.request({
                    url: '/btoa/portal/common/getBankPublicKey',
                    type: 'get',
                    data: {},
                    success: function (data) {
                        console.log(data);
                        localData.publicKey = data.data.publicKey;
                    },
                    error: function () {

                    }
                });
                function createKeyboard(options) {
                    var key = new Keyboard(options);
                    return key;
                }

                createKeyboard({
                    containsID: "keyboardContent",
                    maxLength: '6',
                    id: 'password',
                    placeholder: '输入6位数字交易密码',
                    type: '2',
                    press: function (val, obj) {
                        console.log(obj);
                    },
                    keyPressCallback: function (val) {
                        $('#password').val(val);
                    },
                    blur: function () {
                        self.checkPassword($('#password').val());
                        self.checkNextBtn();
                    }
                });

                createKeyboard({
                    containsID: "keyboardContentToo",
                    maxLength: '6',
                    id: 'repeatPwd',
                    placeholder: '再次输入交易密码',
                    type: '2',
                    press: function (val, obj) {

                    },
                    keyPressCallback: function (val) {
                        $('#repeatPwd').val(val);
                    },
                    blur: function () {
                        self.checkRepeatPwd();
                        self.checkNextBtn();
                    }
                });


            });
        },
        getRecommendData: function (cb) {
            if (typeof cb === 'function') {
                cb();
            }
        },
        setHeader: function () {
            /**
             * 通过地址中的参数判断其是否为”承接流程“，还是”单个流程“
             * 1. 单个流程：有返回按钮，有关闭按钮（关闭按钮没有返回上个流程的加逻辑）。
             * 2. 承接流程：没有返回按钮，有关闭按钮（关闭按钮需要加上 返回上个流程的成功页面），
             */
            var hasBackBtn = (this.source === 'licai');
            Hyperion.actions.setHeader(
                {
                    title: '设置交易密码',
                    //  返回按钮，需要判断是不是流程内的
                    isBack: true,
                    backCallback: function () {
                        Hyperion.actions.back();
                        Hyperion.actions.onEvent({ eventId: "10502-开通_设置交易密码页", eventLable: "1050201-点击“返回”"});
                    },
                    //  关闭按钮，需要判断是不是流程内的
                    isClose: true,
                    closeCallback: function () {
                        if (hasBackBtn) {
                            $('#closeConfim').show().css("height", $('body')[0].scrollHeight);
                        } else {
                            Hyperion.actions.close();
                            Hyperion.actions.onEvent({ eventId: "10502-开通_设置交易密码页", eventLable: "1050202-点击“关闭”"});
                        }
                    }
                }, function () {

                }
            );

        },
        checkNextBtn: function () {
            if (!!inputStatus.password && !!inputStatus.repeatPwd && !!inputStatus.protocol) {
                $('#submit').removeClass('error');
                $('#submit').addClass('active');
            } else {
                $('#submit').addClass('error');
                $('#submit').removeClass('active');
            }
        },
        checkPassword: function (password) {
            var isRepeat = true;
            var format1 = /^(\d)\1+$/; //重复一个字符
            var $idNo = localData.idNo;
            var $phone = localData.mobileNo;
            var $idNoBir = $idNo.substring(6, 14);
            var $repwd = $('#repeatPwd').val(); //
            inputStatus.password = false;
            if (!password || ((password && password.length) !== 6)) {
                Hyperion.actions.tip({
                    text: "请输入6位数字",
                    time: 1500
                });
                return;
            }

            if (password === $idNo.substring(6, 14)) {
                Hyperion.actions.tip({
                    text: "密码不能为生日日期",
                    time: 1500
                });
                return;
            }

            if (password === $idNo.substring(0, 6) || password === $idNo.substring(12, 18)) {
                Hyperion.actions.tip({
                    text: "密码不能为身份证前后6位",
                    time: 1500
                });
                return;
            }
            if ($phone.indexOf(password) !== -1) {
                Hyperion.actions.tip({
                    text: "密码不能为电话号码",
                    time: 1500
                });
                return;
            }

            if ($idNoBir.indexOf(password) !== -1) {
                Hyperion.actions.tip({
                    text: "密码不能为生日日期",
                    time: 1500
                });
                return;
            }

            // 检测是否为重复数字
            if (format1.test(password)) {
                Hyperion.actions.tip({
                    text: "交易密码不能为重复数字",
                    time: 1500
                });
                return;
            } else {
                // 检测是否为连续的数字
                var pArray = password.split("");
                for (var i = 0; i < pArray.length - 1; i++) {
                    if (Math.abs(Number(pArray[i]) - Number(pArray[i + 1])) !== 1) {
                        isRepeat = false;
                        break;
                    }
                }
                if (isRepeat) {
                    Hyperion.actions.tip({
                        text: "交易密码不能为连续的数字",
                        time: 1500
                    });
                    return;
                }
            }
            if ($repwd) {
                if ($repwd !== password) {
                    Hyperion.actions.tip({
                        text: "两次密码输入不符",
                        time: 1500
                    });
                    return;
                } else {
                    inputStatus.repeatPwd = true;
                }
            }
            inputStatus.password = true;

        },
        checkRepeatPwd: function () {
            var password = $('#password').val(),
                repeatPassword = $('#repeatPwd').val();
            inputStatus.repeatPwd = false;
            if (password !== repeatPassword) {
                Hyperion.actions.tip({
                    text: "两次密码输入不符",
                    time: 1500
                });
                return;
            }
            if (password) {
                this.checkPassword(password);
            }
            inputStatus.repeatPwd = true;
        },
        handlers: {
            'E_SubmitError': function () {
                if (inputStatus.protocol === false) {
                    Hyperion.actions.tip({
                        text: '您还未阅读并同意协议',
                        time: 1500
                    });
                } else {
                    Hyperion.actions.tip({
                        text: '请正确填写信息',
                        time: 1500
                    });
                }
            },
            // 点击《xx银行电子账户》跳转到相应页面
            'eProtocal': function () {
                Hyperion.actions.onEvent({ eventId: "10502-开通_设置交易密码页", eventLable: "1050204-点击电子协议"});
                Hyperion.actions.forward({
                    url: 'modules/open-account/1.0.0/views/eProtocal.html'
                });
            },
            'E_SureTap': function () {
                Hyperion.actions.onEvent({ eventId: "10504-开通_关闭确认页", eventLable: "1050401-点击“确定”"});
                Hyperion.actions.close();
            },
            'E_passwordKeyboard': function () {
                self.checkPassword($('#password').val());
                self.checkNextBtn();
            },
            'E_pPasswordBlur': function () {
                self.checkPassword($('#password').val());
                self.checkNextBtn();
            },
            'E_repeatpwdKeyboard': function () {
                self.checkRepeatPwd();
                self.checkNextBtn();
            },
            'E_pRPasswordBlur': function () {
                self.checkRepeatPwd();
                self.checkNextBtn();
            },
            'agreeProtocal': function () {
                Hyperion.actions.onEvent({ eventId: "10502-开通_设置交易密码页", eventLable: "1050203-勾选电子协议"});
                $("#servicesProtocalS").toggleClass('active');
                inputStatus.protocol = ($("#servicesProtocalS").hasClass('active')) ? true : false;
                self.checkNextBtn();
            },
            // 点击"下一步"
            'submit': function () {
                Hyperion.actions.onEvent({ eventId: "10502-开通_设置交易密码页", eventLable: "1050205-点击“确定”"});
                var pwd = $("#password").val();
                localData.pwd = pwd;
                // 获取时间戳
                self.request({
                    url: '/btoa/portal/common/gz/getTimestamp',
                    type: 'get',
                    data: {},
                    success: function (data) {
                        console.log(data);
                        localData.timeStamp = data.data.serviceTime;
                        Hyperion.actions.getEncodedPSW({
                            publicKey: localData.publicKey,
                            data: $('#password').val(),
                            timeStamp: localData.timeStamp
                        }, function (status, result) {
                            if (result) {
                                localData.deilPwd = result;
                                //开户接口
                                self.request({
                                    url: '/btoa/work/account/regElecAccount',
                                    type: 'post',
                                    data: {
                                        'agree': 'Y',
                                        'smsCode': localData.vSMSToken,
                                        'mobileNo': localData.mobileNo,
                                        'trsPassword': localData.deilPwd,//
                                        'idNo': localData.idNo,//
                                        'cifName': localData.cifName,//
                                        'idType': '1'
                                    },
                                    success: function (data) {
                                        var hasBackBtn = (self.source === 'licai');
                                        if (data.code !== '000000') {
                                            Hyperion.actions.tip({
                                                text: data.msg,
                                                time: 2000
                                            });
                                            return;
                                        } else {

                                            Hyperion.actions.getData({
                                                name: 'LoginCacheData'
                                            }, function (error, res) {
                                                var userInfo = res.userInfo || {};
                                                // 18位身份证号码：第7、8、9、10位为出生年份(四位数)，第11、第12位为出生月份，第13、14位代表出生日期，第17位代表性别，奇数为男，偶数为女。
                                                $.extend(userInfo, {
                                                    cnName: localData.cifName,
                                                    idType: "1",
                                                    idNo: localData.idNo,
                                                    sex: localData.idNo.charAt(16) % 2 === 0 ? "F" : "M",
                                                    birthDate: localData.idNo.substr(6, 8).replace(/(\d{4})(\d{2})(\d{2})/, "$1-$2-$3"),
                                                    userType: "2"
                                                });
                                                Hyperion.actions.setData({
                                                    name: 'LoginCacheData',
                                                    value: res
                                                }, function () {
                                                    // 开户成功通知native
                                                    Hyperion.actions.notifyNativeEvent({
                                                        eventName: "createAccount",
                                                        data: {result: "true"}
                                                    });
                                                    if (hasBackBtn) {
                                                        Hyperion.actions.forward({
                                                            url: 'modules/bind-card/1.0.0/views/bindCard.html',
                                                            data: {
                                                                source: 'open'
                                                            }
                                                        });
                                                    } else {
                                                        Hyperion.actions.forward({
                                                            url: 'modules/open-account/1.0.0/views/openAccuSuc.html'
                                                        });
                                                    }
                                                });
                                            });
                                        }
                                    },
                                    error: function () {

                                    }
                                });
                            } else {
                                Hyperion.actions.tip({
                                    text: '服务异常，请稍候再试',
                                    time: 2000
                                });
                            }
                        });
                    },
                    error: function () {
                    }
                });
            },
            // 关闭"提示确认框"
            'E_closeTap': function (e) {
                e.stopImmediatePropagation();
                e.preventDefault();
                $('#closeConfim').hide();
                Hyperion.actions.onEvent({ eventId: "10504-开通_关闭确认页", eventLable: "1050402-点击“关闭”"});
            }
        }
    });
    new Register();
});
